package xyz.veronie.bgg.result;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

public class ThingMetaData {
	private int id;
	private Integer rating;
	private String imgURL;
	private String thumbURL;
	private String comment;
	private Integer otherId; // ???
	private String username;

	private PropertyChangeSupport propertyChangeSupport = new PropertyChangeSupport(this);
	
	public ThingMetaData(int id, Integer rating, String imgURL, String thumbURL, String comment, Integer otherId, String username) {
		this.setId(id);
		this.setRating(rating);
		this.setImgURL(imgURL);
		this.setThumbURL(thumbURL);
		this.setComment(comment);
		this.setOtherId(otherId);
		this.setUsername(username);
	}
	
	public void addPropertyChangeListener(String propertyName,
            PropertyChangeListener listener) {
        propertyChangeSupport.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertyChangeSupport.removePropertyChangeListener(listener);
    }

	public int getId() {
		return id;
	}

	public void setId(int id) {
		propertyChangeSupport.firePropertyChange("id", this.id,
			this.id = id);
	}

	public Integer getRating() {
		return rating;
	}

	public void setRating(Integer rating) {
		propertyChangeSupport.firePropertyChange("rating", this.rating,
			this.rating = rating);
	}

	public String getImgURL() {
		return imgURL;
	}

	public void setImgURL(String imgURL) {
		propertyChangeSupport.firePropertyChange("img", this.imgURL,
			this.imgURL = imgURL);
	}

	public String getThumbURL() {
		return thumbURL;
	}

	public void setThumbURL(String thumbURL) {
		propertyChangeSupport.firePropertyChange("thumb", this.thumbURL,
			this.thumbURL = thumbURL);
	}

	public String getComment() {
		return comment;
	}

	public void setComment(String comment) {
		propertyChangeSupport.firePropertyChange("comment", this.comment,
			this.comment = comment);
	}

	public Integer getOtherId() {
		return otherId;
	}

	public void setOtherId(Integer otherId) {
		propertyChangeSupport.firePropertyChange("otherId", this.otherId,
			this.otherId = otherId);
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(String username) {
		propertyChangeSupport.firePropertyChange("username", this.username,
			this.username = username);
	}
    
	
	@Override
    public String toString() {
        return String.valueOf(id);
    }
    
}

